<?php
namespace gallery\system\event\listener;
use wcf\system\event\IEventListener;
use wcf\data\user\jcoins\statement\UserJcoinsStatementAction;
use wcf\system\WCF;

/**
 * Listen to Image view action for jCoins
 * 
 * @author		Mirco Sarkissian
 * @copyright	2014 Mirco Sarkissian
 * @license		Creative Commons BY-SA <http://creativecommons.org/licenses/by-sa/4.0/>
 * @package		com.ms.gallery.jcoins
 * @subpackage	system.event.listener
 * @category	Community Gallery
 */
class JCoinsMsImageReadListener implements IEventListener {
	/**
	 * @see	wcf\system\event\IEventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		
		// need module
		if (!MODULE_JCOINS) return;
		
		// get data
		// user may read own news without jCoins
		$news = $eventObj->image;
		$userID = WCF::getUser()->userID;
		$sum = JCOINS_RECEIVECOINS_MSIMAGE_READ;
		
		if($userID && $userID != $news->userID && $sum != 0) {
			$action = new UserJcoinsStatementAction(array(), 'create', array(
					'data' => array(
							'reason' => 'wcf.jcoins.statement.imageread.receive',
							'sum' => $sum,
							'userID' => $userID
					),
					'changeBalance' => 1
			));
			$action->validateAction();
			$action->executeAction();
		}
	}
}
